"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
from dataclasses_json import Undefined, dataclass_json
from ding import utils
from enum import Enum
from typing import Optional


class LineType(str, Enum):
    r"""The type of phone line.
      * `CallingCards` - Numbers that are associated with providers of pre-paid domestic and international calling cards.
      * `FixedLine` - Landline phone numbers.
      * `InternetServiceProvider` - Numbers reserved for ISPs.
      * `LocalRate` - Numbers that can be assigned non-geographically.
      * `Mobile` - Mobile phone numbers.
      * `Other` - Other types of services.
      * `Pager` - Number ranges specifically allocated to paging devices.
      * `PayPhone` - Allocated numbers for payphone kiosks in some countries.
      * `PremiumRate` - Landline numbers where the calling party pays more than standard.
      * `Satellite` - Satellite phone numbers.
      * `Service` - Automated applications.
      * `SharedCost` - Specific landline ranges where the cost of making the call is shared between the calling and called party.
      * `ShortCodesCommercial` - Short codes are memorable, easy-to-use numbers, like the UK's NHS 111, often sold to businesses. Not available in all countries.
      * `TollFree` - Number where the called party pays for the cost of the call not the calling party.
      * `UniversalAccess` - Number ranges reserved for Universal Access initiatives.
      * `Unknown` - Unknown phone number type.
      * `VPN` - Numbers are used exclusively within a private telecommunications network, connecting the operator's terminals internally and not accessible via the public telephone network.
      * `VoiceMail` - A specific category of Interactive Voice Response (IVR) services.
      * `Voip` - Specific ranges for providers of VoIP services to allow incoming calls from the regular telephony network.
    """
    CALLING_CARDS = 'CallingCards'
    FIXED_LINE = 'FixedLine'
    INTERNET_SERVICE_PROVIDER = 'InternetServiceProvider'
    LOCAL_RATE = 'LocalRate'
    MOBILE = 'Mobile'
    OTHER = 'Other'
    PAGER = 'Pager'
    PAY_PHONE = 'PayPhone'
    PREMIUM_RATE = 'PremiumRate'
    SATELLITE = 'Satellite'
    SERVICE = 'Service'
    SHARED_COST = 'SharedCost'
    SHORT_CODES_COMMERCIAL = 'ShortCodesCommercial'
    TOLL_FREE = 'TollFree'
    UNIVERSAL_ACCESS = 'UniversalAccess'
    UNKNOWN = 'Unknown'
    VPN = 'VPN'
    VOICE_MAIL = 'VoiceMail'
    VOIP = 'Voip'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class LookupResponse:
    phone_number: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('phone_number'), 'exclude': lambda f: f is None }})
    r"""An E.164 formatted phone number."""
    mcc: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('mcc'), 'exclude': lambda f: f is None }})
    r"""The mobile country code of the phone number."""
    mnc: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('mnc'), 'exclude': lambda f: f is None }})
    r"""The mobile network code of the phone number."""
    caller_name: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('caller_name'), 'exclude': lambda f: f is None }})
    r"""The CNAM (Caller ID Name) associated with the phone number. Contact us if you need to use this functionality. Once enabled, put `cnam` option to `type` query parameter."""
    carrier: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('carrier'), 'exclude': lambda f: f is None }})
    r"""The carrier of the phone number."""
    country_code: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('country_code'), 'exclude': lambda f: f is None }})
    r"""The ISO 3166-1 alpha-2 country code of the phone number."""
    number_ported: Optional[bool] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('number_ported'), 'exclude': lambda f: f is None }})
    r"""Whether the phone number has been ported."""
    temporary_phone_number: Optional[bool] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('temporary_phone_number'), 'exclude': lambda f: f is None }})
    r"""Whether the phone number is in our database of disposable, temporary phone numbers"""
    line_type: Optional[LineType] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('line_type'), 'exclude': lambda f: f is None }})
    r"""The type of phone line.
      * `CallingCards` - Numbers that are associated with providers of pre-paid domestic and international calling cards.
      * `FixedLine` - Landline phone numbers.
      * `InternetServiceProvider` - Numbers reserved for ISPs.
      * `LocalRate` - Numbers that can be assigned non-geographically.
      * `Mobile` - Mobile phone numbers.
      * `Other` - Other types of services.
      * `Pager` - Number ranges specifically allocated to paging devices.
      * `PayPhone` - Allocated numbers for payphone kiosks in some countries.
      * `PremiumRate` - Landline numbers where the calling party pays more than standard.
      * `Satellite` - Satellite phone numbers.
      * `Service` - Automated applications.
      * `SharedCost` - Specific landline ranges where the cost of making the call is shared between the calling and called party.
      * `ShortCodesCommercial` - Short codes are memorable, easy-to-use numbers, like the UK's NHS 111, often sold to businesses. Not available in all countries.
      * `TollFree` - Number where the called party pays for the cost of the call not the calling party.
      * `UniversalAccess` - Number ranges reserved for Universal Access initiatives.
      * `Unknown` - Unknown phone number type.
      * `VPN` - Numbers are used exclusively within a private telecommunications network, connecting the operator's terminals internally and not accessible via the public telephone network.
      * `VoiceMail` - A specific category of Interactive Voice Response (IVR) services.
      * `Voip` - Specific ranges for providers of VoIP services to allow incoming calls from the regular telephony network.
    """
    

